Index: /LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 1001)
@@ -11,4 +11,5 @@
       USE pbl_surface_mod,  ONLY : pbl_surface_final
       USE phys_state_var_mod
+      USE iostart
 
       IMPLICIT none
@@ -29,53 +30,16 @@
 
 c les variables globales ecrites dans le fichier restart
-      REAL rlat_glo(klon_glo), rlon_glo(klon_glo)
-      REAL pctsrf_glo(klon_glo, nbsrf)
-      REAL tsol_glo(klon_glo,nbsrf)
-      REAL alb1_glo(klon_glo,nbsrf)
-      REAL alb2_glo(klon_glo,nbsrf)
-      REAL rain_fall_glo(klon_glo)
-      REAL snow_fall_glo(klon_glo)
-      real solsw_glo(klon_glo)
-      real sollw_glo(klon_glo)
-      REAL radsol_glo(klon_glo)
-      REAL zmea_glo(klon_glo)
-      REAL zstd_glo(klon_glo)
-      REAL zsig_glo(klon_glo)
-      REAL zgam_glo(klon_glo)
-      REAL zthe_glo(klon_glo)
-      REAL zpic_glo(klon_glo)
-      REAL zval_glo(klon_glo)
-      REAL rugsrel_glo(klon_glo)
-      REAL t_ancien_glo(klon_glo,klev), q_ancien_glo(klon_glo,klev)
-      REAL clwcon_glo(klon_glo,klev)
-      REAL rnebcon_glo(klon_glo,klev) 
-      REAL ratqs_glo(klon_glo,klev)
-      REAL pbl_tke_glo(klon_glo,klev+1,nbsrf)
-      REAL zmax0_glo(klon_glo), f0_glo(klon)
-      REAL ema_work1_glo(klon_glo, klev), ema_work2_glo(klon_glo, klev)
-      REAL wake_deltat_glo(klon_glo,klev),wake_deltaq_glo(klon_glo,klev)
-      REAL wake_s_glo(klon_glo), wake_cstar_glo(klon_glo)
-      REAL wake_fip_glo(klon_glo)
-
-      REAL tsoil_p(klon,nsoilmx,nbsrf)
-      REAL qsurf_p(klon,nbsrf)
-      REAL qsol_p(klon)
-      REAL snow_p(klon,nbsrf)
-      REAL evap_p(klon,nbsrf)
-      real fder_p(klon)
-      REAL frugs_p(klon,nbsrf)
-      REAL agesno_p(klon,nbsrf)
-      REAL run_off_lic_0_p(klon)
-      
-      REAL tsoil(klon_glo,nsoilmx,nbsrf)
-      REAL qsurf(klon_glo,nbsrf)
-      REAL qsol(klon_glo)
-      REAL snow(klon_glo,nbsrf)
-      REAL evap(klon_glo,nbsrf)
-      real fder(klon_glo)
-      REAL frugs(klon_glo,nbsrf)
-      REAL agesno(klon_glo,nbsrf)
-      REAL run_off_lic_0(klon_glo)
-      REAL masq(klon_glo)
+
+      
+      REAL tsoil(klon,nsoilmx,nbsrf)
+      REAL tslab(klon), seaice(klon)
+      REAL qsurf(klon,nbsrf)
+      REAL qsol(klon)
+      REAL snow(klon,nbsrf)
+      REAL evap(klon,nbsrf)
+      real fder(klon)
+      REAL frugs(klon,nbsrf)
+      REAL agesno(klon,nbsrf)
+      REAL run_off_lic_0(klon)
 c
       INTEGER nid, nvarid, idim1, idim2, idim3
@@ -93,77 +57,14 @@
 c Get variables which will be written to restart file from module 
 c pbl_surface_mod
-      CALL pbl_surface_final(qsol_p, fder_p, snow_p, qsurf_p, 
-     $     evap_p, frugs_p, agesno_p, tsoil_p)
+      CALL pbl_surface_final(qsol, fder, snow, qsurf, 
+     $     evap, frugs, agesno, tsoil)
 
 c Get a variable calculated in module fonte_neige_mod
-      CALL fonte_neige_final(run_off_lic_0_p)
-
-c======================================================================
-
-      call Gather( rlat,rlat_glo)
-      call Gather( rlon,rlon_glo)
-      call Gather( pctsrf,pctsrf_glo)
-      call Gather( ftsol,tsol_glo)
-      call Gather( falb1,alb1_glo)
-      call Gather( falb2,alb2_glo)
-      call Gather( rain_fall,rain_fall_glo)
-      call Gather( snow_fall,snow_fall_glo)
-      call Gather( sollw,sollw_glo)
-      call Gather( solsw,solsw_glo)
-      call Gather( radsol,radsol_glo)
-      call Gather( zmea,zmea_glo)
-      call Gather( zstd,zstd_glo)
-      call Gather( zsig,zsig_glo)
-      call Gather( zgam,zgam_glo)
-      call Gather( zthe,zthe_glo)
-      call Gather( zpic,zpic_glo)
-      call Gather( zval,zval_glo)
-      call Gather( rugoro,rugsrel_glo)
-      call Gather( t_ancien,t_ancien_glo)
-      call Gather( q_ancien,q_ancien_glo)
-      call Gather( clwcon,clwcon_glo)
-      call Gather( rnebcon,rnebcon_glo)
-      call Gather( ratqs,ratqs_glo)
-      call Gather( pbl_tke,pbl_tke_glo)
-      call Gather( zmax0,zmax0_glo)
-      call Gather( f0,f0_glo)
-      call Gather( ema_work1, ema_work1_glo)
-      call Gather( ema_work2, ema_work2_glo)
-      call Gather( wake_deltat, wake_deltat_glo)
-      call Gather( wake_deltaq, wake_deltaq_glo)
-      call Gather( wake_s, wake_s_glo)
-      call Gather( wake_cstar, wake_cstar_glo)
-      call Gather( wake_fip, wake_fip_glo)
-
-      call Gather( tsoil_p,tsoil)
-      call Gather( qsurf_p,qsurf)
-      call Gather( qsol_p,qsol)
-      call Gather( snow_p,snow)
-      call Gather( evap_p,evap)
-      call Gather( fder_p,fder)
-      call Gather( frugs_p,frugs)
-      call Gather( agesno_p,agesno)
-      call Gather( run_off_lic_0_p,run_off_lic_0)
-      call Gather( zmasq,masq)
-      
-c$OMP MASTER
-      IF (is_mpi_root) THEN
-      
-      ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
-      IF (ierr.NE.NF_NOERR) THEN
-        write(6,*)' Pb d''ouverture du fichier '//fichnom
-        write(6,*)' ierr = ', ierr
-        CALL ABORT
-      ENDIF
-c
-      ierr = NF_PUT_ATT_TEXT (nid, NF_GLOBAL, "title", 28,
-     .                       "Fichier redemmarage physique")
-c
-      ierr = NF_DEF_DIM (nid, "index", length, idim1)
-      ierr = NF_DEF_DIM (nid, "points_physiques", klon_glo, idim2)
-      ierr = NF_DEF_DIM (nid, "horizon_vertical", klon_glo*klev, idim3)
-c
-      ierr = NF_ENDDEF(nid)
-c
+      CALL fonte_neige_final(run_off_lic_0)
+
+c======================================================================
+
+      CALL open_restartphy(fichnom)
+      
       DO ierr = 1, length
          tab_cntrl(ierr) = 0.0
@@ -186,442 +87,142 @@
       tab_cntrl(15) = itau_phy
 c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "controle", NF_DOUBLE, 1, idim1,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "controle", NF_FLOAT, 1, idim1,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 22,
-     .                        "Parametres de controle")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tab_cntrl)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,tab_cntrl)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "longitude", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "longitude", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 32,
-     .                        "Longitudes de la grille physique")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlon_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlon_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "latitude", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "latitude", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 31,
-     .                        "Latitudes de la grille physique")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlat_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rlat_glo)
-#endif
+      CALL put_var("controle","Parametres de controle",tab_cntrl)
+c
+
+      CALL put_field("longitude",
+     .               "Longitudes de la grille physique",rlon)
+     
+      CALL put_field("latitude","Latitudes de la grille physique",rlat)
+
 c
 C PB ajout du masque terre/mer
 C
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "masque", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "masque", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 16,
-     .                        "masque terre mer")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,masq)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,masq)
-#endif      
+      CALL put_field("masque","masque terre mer",zmasq)
+
 c BP ajout des fraction de chaque sous-surface
 C
 C 1. fraction de terre 
 C
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "FTER", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "FTER", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
-     .                        "fraction de continent")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf_glo(1 : klon_glo,     &
-     &   is_ter))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf_glo(1 : klon_glo,       &
-     &    is_ter))
-#endif
+      CALL put_field("FTER","fraction de continent",pctsrf(:,is_ter))
 C 
 C 2. Fraction de glace de terre
 C 
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "FLIC", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "FLIC", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 24,
-     .                        "fraction glace de terre")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf_glo(1 : klon_glo,
-     &                          is_lic))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf_glo(1 : klon_glo, 
-     &                        is_lic))
-#endif
+      CALL put_field("FLIC","fraction glace de terre",pctsrf(:,is_lic))
 C
 C 3. fraction ocean
 C
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "FOCE", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "FOCE", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 14,
-     .                        "fraction ocean")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf_glo(1 : klon_glo,
-     &                          is_oce))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf_glo(1 : klon_glo,
-     &                        is_oce))
-#endif
+      CALL put_field("FOCE","fraction ocean",pctsrf(:,is_oce))
 C
 C 4. Fraction glace de mer
 C
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "FSIC", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "FSIC", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 18,
-     .                        "fraction glace mer")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pctsrf_glo(1 : klon_glo, 
-     &                          is_sic))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pctsrf_glo(1 : klon_glo,
-     &                         is_sic))
-#endif
-C
-C
+      CALL put_field("FSIC","fraction glace mer",pctsrf(:,is_sic))
+C
+C
+c
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("TS"//str2,"Temperature de surface No."//str2,
+     .                    ftsol(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      ENDDO
+c
+      DO nsrf = 1, nbsrf
+        DO isoil=1, nsoilmx
+          IF (isoil.LE.99 .AND. nsrf.LE.99) THEN
+            WRITE(str7,'(i2.2,"srf",i2.2)') isoil,nsrf
+            CALL put_field("Tsoil"//str7,"Temperature du sol No."//str7,
+     .                     tsoil(:,isoil,nsrf))
+          ELSE
+            PRINT*, "Trop de couches"
+            CALL abort
+          ENDIF
+        ENDDO
+      ENDDO
+c
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("QS"//str2,"Humidite de surface No."//str2,
+     .                   qsurf(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      END DO
+C
+      CALL put_field("QSOL","Eau dans le sol (mm)",qsol)
+c
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("ALBE"//str2,"albedo de surface No."//str2,
+     .                   falb1(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      ENDDO
+
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("ALBLW"//str2,"albedo LW de surface No."//str2,
+     .                   falb2(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      ENDDO
+c
+c
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("EVAP"//str2,"Evaporation de surface No."//str2
+     .                   ,evap(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      ENDDO
+
+c
+      DO nsrf = 1, nbsrf
+        IF (nsrf.LE.99) THEN
+          WRITE(str2,'(i2.2)') nsrf
+          CALL put_field("SNOW"//str2,"Neige de surface No."//str2,
+     .                   snow(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
+      ENDDO
+
+c
+      CALL put_field("RADS","Rayonnement net a la surface",radsol)
+c
+      CALL put_field("solsw","Rayonnement solaire a la surface",solsw)
+c
+      CALL put_field("sollw","Rayonnement IF a la surface",sollw)
+c
+      CALL put_field("fder","Derive de flux",fder)
+c
+      CALL put_field("rain_f","precipitation liquide",rain_fall)
+c
+      CALL put_field("snow_f", "precipitation solide",snow_fall)
 c
       DO nsrf = 1, nbsrf
         IF (nsrf.LE.99) THEN
         WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid, "TS"//str2, NF_DOUBLE, 1, idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid, "TS"//str2, NF_FLOAT, 1, idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Temperature de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tsol_glo(1,nsrf))
-#else
-        ierr = NF_PUT_VAR_REAL (nid,nvarid,tsol_glo(1,nsrf))
-#endif
-      ENDDO
-c
-      DO nsrf = 1, nbsrf
-      DO isoil=1, nsoilmx
-        IF (isoil.LE.99 .AND. nsrf.LE.99) THEN
-        WRITE(str7,'(i2.2,"srf",i2.2)') isoil,nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid, "Tsoil"//str7,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid, "Tsoil"//str7,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 29,
-     .                        "Temperature du sol No."//str7)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de couches"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,tsoil(1,isoil,nsrf))
-#else
-        ierr = NF_PUT_VAR_REAL (nid,nvarid,tsoil(1,isoil,nsrf))
-#endif
-      ENDDO
-      ENDDO
-c
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"QS"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"QS"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 25,
-     .                        "Humidite de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,qsurf(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,qsurf(1,nsrf))
-#endif
-      END DO
-C
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid,"QSOL",NF_DOUBLE,1,idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid,"QSOL",NF_FLOAT,1,idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
-     .    "Eau dans le sol (mm)")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,qsol)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,qsol)
-#endif
-c
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"ALBE"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"ALBE"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 23,
-     .                        "albedo de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,alb1_glo(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,alb1_glo(1,nsrf))
-#endif
-      ENDDO
-
-        DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"ALBLW"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"ALBLW"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 23,
-     .                        "albedo LW de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,alb2_glo(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,alb2_glo(1,nsrf))
-#endif
-      ENDDO
-c
-c
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"EVAP"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"EVAP"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Evaporation de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,evap(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,evap(1,nsrf))
-#endif
-      ENDDO
-
-c
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"SNOW"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"SNOW"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 22,
-     .                        "Neige de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,snow(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,snow(1,nsrf))
-#endif
-      ENDDO
-
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "RADS", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "RADS", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Rayonnement net a la surface")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,radsol_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,radsol_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "solsw", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "solsw", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 32,
-     .                        "Rayonnement solaire a la surface")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,solsw_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,solsw_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "sollw", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "sollw", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 27,
-     .                        "Rayonnement IF a la surface")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,sollw_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,sollw_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "fder", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "fder", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 14,
-     .                        "Derive de flux")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,fder)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,fder)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "rain_f", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "rain_f", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 21,
-     .                        "precipitation liquide")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rain_fall_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rain_fall_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "snow_f", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "snow_f", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 20,
-     .                        "precipitation solide")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,snow_fall_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,snow_fall_glo)
-#endif
-c
-       endif
-c$OMP END MASTER
-cc ----> necessaire pour eviter bug openMP sur SX6
-c$OMP MASTER
-      if (is_mpi_root) then
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
-        WRITE(str2,'(i2.2)') nsrf
-        ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-        ierr = NF_DEF_VAR (nid,"RUG"//str2,NF_DOUBLE,1,idim2,nvarid)
-#else
-        ierr = NF_DEF_VAR (nid,"RUG"//str2,NF_FLOAT,1,idim2,nvarid)
-#endif
-        ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 23,
-     .                        "rugosite de surface No."//str2)
-        ierr = NF_ENDDEF(nid)
-        ELSE
-        PRINT*, "Trop de sous-mailles"
-        CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,frugs(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,frugs(1,nsrf))
-#endif
+          CALL put_field("RUG"//str2,"rugosite de surface No."//str2,
+     .         frugs(:,nsrf))
+        ELSE
+          PRINT*, "Trop de sous-mailles"
+          CALL abort
+        ENDIF
       ENDDO
 c
@@ -629,226 +230,45 @@
         IF (nsrf.LE.99) THEN
             WRITE(str2,'(i2.2)') nsrf
-            ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-            ierr = NF_DEF_VAR (nid,"AGESNO"//str2,NF_DOUBLE,1,idim2
-     $          ,nvarid)
-#else
-            ierr = NF_DEF_VAR (nid,"AGESNO"//str2,NF_FLOAT,1,idim2
-     $          ,nvarid)
-#endif
-            ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 15,
-     .                        "Age de la neige surface No."//str2)
-            ierr = NF_ENDDEF(nid)
+            CALL put_field("AGESNO"//str2,
+     .                     "Age de la neige surface No."//str2,
+     .                     agesno(:,nsrf))
         ELSE
             PRINT*, "Trop de sous-mailles"
             CALL abort
         ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,agesno(1,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,agesno(1,nsrf))
-#endif
-      ENDDO
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZMEA", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZMEA", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zmea_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zmea_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZSTD", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZSTD", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zstd_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zstd_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZSIG", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZSIG", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zsig_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zsig_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZGAM", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZGAM", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zgam_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zgam_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZTHE", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZTHE", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zthe_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zthe_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZPIC", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZPIC", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zpic_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zpic_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "ZVAL", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "ZVAL", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,zval_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,zval_glo)
-#endif
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "RUGSREL", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "RUGSREL", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rugsrel_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rugsrel_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "TANCIEN", NF_DOUBLE, 1, idim3,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "TANCIEN", NF_FLOAT, 1, idim3,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,t_ancien_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,t_ancien_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "QANCIEN", NF_DOUBLE, 1, idim3,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "QANCIEN", NF_FLOAT, 1, idim3,nvarid)
-#endif
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,q_ancien_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,q_ancien_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "RUGMER", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "RUGMER", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Longueur de rugosite sur mer")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,frugs(1,is_oce))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,frugs(1,is_oce))
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "CLWCON", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "CLWCON", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Eau liquide convective")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,clwcon_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,clwcon_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "RNEBCON", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "RNEBCON", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Nebulosite convective")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rnebcon_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,rnebcon_glo)
-#endif
-c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr = NF_DEF_VAR (nid, "RATQS", NF_DOUBLE, 1, idim2,nvarid)
-#else
-      ierr = NF_DEF_VAR (nid, "RATQS", NF_FLOAT, 1, idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 28,
-     .                        "Ratqs")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,ratqs_glo)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,ratqs_glo)
-#endif
+      ENDDO
+c
+      CALL put_field("ZMEA","",zmea)
+c
+      CALL put_field("ZSTD","",zstd)
+      
+      CALL put_field("ZSIG","",zsig)
+      
+      CALL put_field("ZGAM","",zgam)
+      
+      CALL put_field("ZTHE","",zthe)
+      
+      CALL put_field("ZPIC","",zpic)
+      
+      CALL put_field("ZVAL","",zval)
+      
+      CALL put_field("RUGSREL","RUGSREL",rugoro)
+      
+      CALL put_field("TANCIEN","",t_ancien)
+      
+      CALL put_field("QANCIEN","",q_ancien)
+      
+      CALL put_field("RUGMER","Longueur de rugosite sur mer",
+     .               frugs(:,is_oce))
+      
+      CALL put_field("CLWCON","Eau liquide convective",clwcon(:,1))
+      
+      CALL put_field("RNEBCON","Nebulosite convective",rnebcon(:,1))
+      
+      CALL put_field("RATQS", "Ratqs",ratqs(:,1))
 c
 c run_off_lic_0
 c
-      ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-      ierr=NF_DEF_VAR(nid,"RUNOFFLIC0",NF_DOUBLE,1,idim2,nvarid)
-#else
-      ierr=NF_DEF_VAR(nid,"RUNOFFLIC0",NF_FLOAT, 1,idim2,nvarid)
-#endif
-      ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 10,
-     .                        "Runofflic0")
-      ierr = NF_ENDDEF(nid)
-#ifdef NC_DOUBLE
-      ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,run_off_lic_0)
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,run_off_lic_0)
-#endif
+      CALL put_field("RUNOFFLIC0","Runofflic0",run_off_lic_0)
 c
 c
@@ -856,28 +276,14 @@
 c
       IF (iflag_pbl>1) then
-      DO nsrf = 1, nbsrf
-        IF (nsrf.LE.99) THEN
+        DO nsrf = 1, nbsrf
+          IF (nsrf.LE.99) THEN
             WRITE(str2,'(i2.2)') nsrf
-            ierr = NF_REDEF (nid)
-#ifdef NC_DOUBLE
-            ierr = NF_DEF_VAR (nid,"TKE"//str2,NF_DOUBLE,1,idim3
-     $          ,nvarid)
-#else
-            ierr = NF_DEF_VAR (nid,"TKE"//str2,NF_FLOAT,1,idim3
-     $          ,nvarid)
-#endif
-            ierr = NF_PUT_ATT_TEXT (nid,nvarid,"title", 15,
-     .                        "Energ. Cineti. Turb."//str2)
-            ierr = NF_ENDDEF(nid)
-        ELSE
+            CALL put_field("TKE"//str2,"Energ. Cineti. Turb."//str2,
+     .                     pbl_tke(:,1:klev,nsrf))
+          ELSE
             PRINT*, "Trop de sous-mailles"
             CALL abort
-        ENDIF
-#ifdef NC_DOUBLE
-        ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,pbl_tke_glo(:,:,nsrf))
-#else
-      ierr = NF_PUT_VAR_REAL (nid,nvarid,pbl_tke_glo(:,:,nsrf))
-#endif
-      ENDDO
+          ENDIF
+        ENDDO
       ENDIF
 
